"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _ImageZoom = _interopRequireDefault(require("./ImageZoom"));

var _ImageLoader = _interopRequireDefault(require("./ImageLoader"));

var _style = require("./style");

var _aliba = require("aliba");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ImageZoom =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ImageZoom, _React$PureComponent);

  function ImageZoom() {
    var _getPrototypeOf2;

    var _temp, _this;

    _classCallCheck(this, ImageZoom);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ImageZoom)).call.apply(_getPrototypeOf2, [this].concat(args))), _this.state = {
      url: '',
      degree: 0
    }, _temp));
  }

  _createClass(ImageZoom, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement(_ImageZoom["default"], this.reactImageZoomProps, this.renderChildren);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadRotateImage(true);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      if (!!this.props.rotate) {
        if (prevProps.src !== this.props.src) {
          // image changed
          // reload images
          delete this.imageLoader;
          this.setState({
            degree: 0
          }, function () {
            _this2.loadRotateImage(true);
          });
        } else if (prevState.degree !== this.state.degree) {
          // degree changed
          var ignoreCallback = this.state.degree === 0;
          this.loadRotateImage(ignoreCallback);

          if (ignoreCallback) {
            // unnecessary to load image degree 0
            this.setState({
              url: ''
            });
          }
        }
      }
    }
  }, {
    key: "rotateIt",
    value: function rotateIt() {
      var clockwise = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.setState(function (state) {
        if (state.degree === 270 && clockwise === true) {
          return {
            degree: 0
          };
        }

        if (state.degree === 0 && clockwise === false) {
          return {
            degree: 270
          };
        } else {
          if (clockwise === true) {
            return {
              degree: state.degree + 90
            };
          } else {
            return {
              degree: state.degree - 90
            };
          }
        }
      });
    }
  }, {
    key: "loadRotateImage",
    value: function loadRotateImage(ignoreCallback) {
      var _this3 = this;

      var _this$props = this.props,
          rotate = _this$props.rotate,
          src = _this$props.src;
      var degree = this.state.degree;

      if (!rotate && !degree) {
        // rotate not allowed
        // unnecessary to load degree 0
        return;
      }

      if (typeof this.imageLoader === 'undefined') {
        this.imageLoader = new _ImageLoader["default"](src);
      }

      if (!ignoreCallback) {
        this.imageLoader.draw(degree, function (blobURL) {
          _this3.setState({
            url: blobURL
          });
        });
      }
    }
  }, {
    key: "renderChildren",
    get: function get() {
      if (typeof this.props.rotate === 'function') {
        return this.props.rotate(this.rotateIt.bind(this, true), this.rotateIt.bind(this, false));
      }

      return '';
    }
  }, {
    key: "reactImageZoomProps",
    get: function get() {
      var url = this.state.url;
      var _this$props2 = this.props,
          width = _this$props2.width,
          height = _this$props2.height,
          zoomWidth = _this$props2.zoomWidth,
          src = _this$props2.src,
          scale = _this$props2.scale,
          offset = _this$props2.offset,
          zoomStyle = _this$props2.zoomStyle,
          zoomLensStyle = _this$props2.zoomLensStyle;
      return {
        width: width,
        height: height,
        zoomWidth: zoomWidth,
        img: url || src,
        scale: scale,
        offset: offset,
        zoomStyle: (0, _aliba.hyphenateCss)(Object.assign({}, _style.defaultZoomStyle, zoomStyle)),
        zoomLensStyle: (0, _aliba.hyphenateCss)(Object.assign({}, _style.defaultZoomLensStyle, zoomLensStyle))
      };
    }
  }]);

  return ImageZoom;
}(_react["default"].PureComponent);

exports["default"] = ImageZoom;